////////////////////////////////////////////////////////////////////////////
// File:	BrowseEdit.h
// Version:	1.0.0.1
// Created:	05-Mar-2002
//
// Author:	Paul S. Vickery
// E-mail:	paul@vickeryhome.freeserve.co.uk
//
// Edit control with embedded ... (ellipsis) button
//
// You are free to use or modify this code, with no restrictions, other than
// you continue to acknowledge me as the original author in this source code,
// or any code derived from it.
//
// If you use this code, or use it as a base for your own code, it would be 
// nice to hear from you simply so I know it's not been a waste of time!
//
// Copyright (c) 2001-2002 Paul S. Vickery
//
////////////////////////////////////////////////////////////////////////////
// Version History:
//
// Version 1.0.0.1 - 05-Mar-2002
// =============================
// Fixes problem with a BrowseEdit created with ES_READONLY not having button
// disabled.
//
// Version 1.0.0.0 - 27-Jul-2001
// =============================
// Initial version.
// 
////////////////////////////////////////////////////////////////////////////
// PLEASE LEAVE THIS HEADER INTACT
////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BROWSEEDIT_H__FB677C14_B950_11D4_A7D8_0000B48746CF__INCLUDED_)
#define AFX_BROWSEEDIT_H__FB677C14_B950_11D4_A7D8_0000B48746CF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BrowseEdit.h : header file
//

// CBrowseEditButton window
class CBrowseEditButton : public CButton
{
public:
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CBrowseEditButton)
  //}}AFX_VIRTUAL

  // Generated message map functions
protected:
  //{{AFX_MSG(CBrowseEditButton)
  afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CBrowseEdit control

class CBrowseEdit : public CWnd
{
// Construction
public:
	CBrowseEdit();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBrowseEdit)
	protected:
	virtual void PreSubclassWindow();
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
  BOOL Create(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID);
  virtual ~CBrowseEdit();
  void SetFont(CFont *pFont, BOOL bRedraw = TRUE) { m_pEdit->SetFont(pFont, bRedraw); m_pBtn->SetFont(pFont, bRedraw); }
  void SetWindowText(LPCTSTR lpszText) { m_pEdit->SetWindowText(lpszText); }
  void GetWindowText(CString &rText) const { m_pEdit->GetWindowText(rText); }
  int GetWindowText(LPTSTR lpszBuffer, int nMax) const { return m_pEdit->GetWindowText(lpszBuffer, nMax); }
  int GetWindowTextLength() const { return m_pEdit->GetWindowTextLength(); }
  CEdit* GetEditControl() const { return m_pEdit; }

protected:
  CEdit* m_pEdit;
  CBrowseEditButton* m_pBtn;

	// Generated message map functions
	//{{AFX_MSG(CBrowseEdit)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnEnable(BOOL bEnable);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BROWSEEDIT_H__FB677C14_B950_11D4_A7D8_0000B48746CF__INCLUDED_)
